import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { getINV } from "../controller/getinventory.js";
import { getFakeEDI } from "../controller/fakeEDIUpdate.js";
import { apiHit } from "../../../globalUtils/apiHits.js";

const app = new OpenAPIHono({ strict: false });
const Body = z.object({
    address: z.string().openapi({ example: "x" }),
});
app.openapi(
    createRoute({
        tags: ["dataMart"],
        summary: "Returns all open orders that need to be updated in fake edi.",
        method: "get",
        path: "/fakeediupdate",
        request: {
            body: {
                content: {
                    "application/json": { schema: Body },
                },
            },
        },
        responses: responses(),
    }),
    async (c) => {
        const address: string = c.req.query("address") ?? "";

        // make sure we have a vaid user being accessed thats really logged in
        apiHit(c, { endpoint: "/fakeediupdate" });
        const { data, error } = await tryCatch(
            getFakeEDI(address.toString() ?? "")
        );

        if (error) {
            return c.json(
                {
                    success: false,
                    message: "There was an error getting the inv.",
                    data: error,
                },
                400
            );
        }

        return c.json({
            success: data.success,
            message: data.message,
            data: data.data,
        });
    }
);
export default app;
